<?php
namespace Creativetableajax;

use Creativetableajax\PageSettings\Page_Settings;
define( "bwdadt_ASFSK_ASSETS_PUBLIC_DIR_FILE", plugin_dir_url( __FILE__ ) . "assets/public" );
define( "bwdadt_ASFSK_ASSETS_ADMIN_DIR_FILE", plugin_dir_url( __FILE__ ) . "assets/admin" );
class ClassbwdadtCreativeTable {

	private static $_instance = null;

	public static function instance() {
		if ( is_null( self::$_instance ) ) {
			self::$_instance = new self();
		}
		return self::$_instance;
	}

	public function bwdadt_admin_editor_scripts() {
		add_filter( 'script_loader_tag', [ $this, 'bwdadt_admin_editor_scripts_as_a_module' ], 10, 2 );
	}

	public function bwdadt_admin_editor_scripts_as_a_module( $tag, $handle ) {
		if ( 'bwdadt_creative_table_editor' === $handle ) {
			$tag = str_replace( '<script', '<script type="module"', $tag );
		}

		return $tag;
	}

	private function include_widgets_files() {
		require_once( __DIR__ . '/widgets/bwdadt-creativeTable.php' );
	}

	public function bwdadt_register_widgets() {
		// Its is now safe to include Widgets files
		$this->include_widgets_files();

		// Register WidgetsF
		\Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Widgets\bwdadt_creativetable());
	}

	private function add_page_settings_controls() {
		require_once( __DIR__ . '/page-settings/bwdadt-creativetable-manager.php' );
		new Page_Settings();
	}

	// Register Category
	function bwdadt_add_elementor_widget_categories( $elements_manager ) {

		$elements_manager->add_category(
			'bwdadt-creative-table-category',
			[
				'title' => esc_html__( 'Ajax DataTable', 'bwdadt-creative-table' ),
				'icon' => 'eicon-person',
			]
		);
	}
	public function bwdadt_all_assets_for_the_public(){

		wp_enqueue_script( 'bwdadt_creativetable_datatablesjs', plugin_dir_url( __FILE__ ) . 'assets/public/js/datatables.min.js', array('jquery'), '1.3', true );

		wp_enqueue_script( 'bwdadt_creativetable_datatablesresponsivejs', plugin_dir_url( __FILE__ ) . 'assets/public/js/dataTables.responsive.min.js', array('jquery'), '1.3', true );
		
		wp_enqueue_script( 'bwdadt_creativetable_mainjs', plugin_dir_url( __FILE__ ) . 'assets/public/js/main.js', array('jquery'), '1.3', true );
		$all_css_js_file = array(

            'bwdadt_creativetable_plugin_datatablescss' => array('bwdadt_path_define'=>bwdadt_ASFSK_ASSETS_PUBLIC_DIR_FILE . '/css/datatables.min.css'),

            'bwdadt_creativetable_plugin_datatablesresponsivecss' => array('bwdadt_path_define'=>bwdadt_ASFSK_ASSETS_PUBLIC_DIR_FILE . '/css/responsive.dataTables.min.css'),

			'bwdadt_creativetable_plugin_fontawesomecss' => array('bwdadt_path_define'=>bwdadt_ASFSK_ASSETS_PUBLIC_DIR_FILE . '/fontawesome/css/all.min.css'),

            'bwdadt_creativetable_plugin_maincss' => array('bwdadt_path_define'=>bwdadt_ASFSK_ASSETS_PUBLIC_DIR_FILE . '/css/main.css'),
        );
        foreach($all_css_js_file as $handle => $fileinfo){
            wp_enqueue_style( $handle, $fileinfo['bwdadt_path_define'], null, '1.3', 'all');
        }
	}

	public function bwdadt_all_assets_for_elementor_editor_admin(){
		$all_css_js_file = array(
            'bwdadt_creativetable_admin_main_css' => array('bwdadt_path_admin_define'=>bwdadt_ASFSK_ASSETS_ADMIN_DIR_FILE . '/icon.css'),
        );
        foreach($all_css_js_file as $handle => $fileinfo){
            wp_enqueue_style( $handle, $fileinfo['bwdadt_path_admin_define'], null, '1.3', 'all');
        }
	}
	
	public function __construct() {

		// For public assets
		add_action('wp_enqueue_scripts', [$this, 'bwdadt_all_assets_for_the_public']);

		// For Elementor Editor
		add_action('elementor/editor/before_enqueue_scripts', [$this, 'bwdadt_all_assets_for_elementor_editor_admin']);
		
		// Register Category
		add_action( 'elementor/elements/categories_registered', [ $this, 'bwdadt_add_elementor_widget_categories' ] );

		// Register widgets
		add_action( 'elementor/widgets/widgets_registered', [ $this, 'bwdadt_register_widgets' ] );

		// Register editor scripts
		add_action( 'elementor/editor/after_enqueue_scripts', [ $this, 'bwdadt_admin_editor_scripts' ] );
		
		$this->add_page_settings_controls();
	}
}

// Instantiate Plugin Class
Classbwdadtcreativetable::instance();